=== epan/dissectors/dcerpc/drsuapi/Makefile ===
# $Id: Makefile 30424 2009-10-09 09:34:07Z krj $

PROTOCOL_NAME=drsuapi
include ../Makefile.inc
